'// Receiver
'// Broadcast datagram to multiple recipients
'// Author Patrice Terrier
'// www.zapsolution.com
'// Date: 10-06-2015

#BREAK ON
#COMPILE EXE "Receiver.exe"
#Include "win32api.inc"
#Include "time.inc"

%PORT_NUMBER = 8000
$DEST_ADDR   = "255.255.255.255"
%BUFFER_SIZE = 4096
 
function pbmain() as long
    local lps as DWORD                    '// Socket descriptor of server
    local nDoIt, broadcast, current_time as long
    local sendaddr as sockaddr_in
    local recvaddr as sockaddr_in
    local addr_len as long
    local wsa as WSADATA                  '// Used to open windows connection
 
    '// Open windows connection
    if (WSAStartup(&h0202, wsa)) then
        print "Could not open Windows connection."
        function = 0: exit function
    end if

    nDoIt = -1
    lps = socket(%AF_INET, %SOCK_DGRAM, byval %NULL)
    if (lps = %INVALID_SOCKET) then
        print "Could not create socket."
        lps = 0
        nDoIt = 0
    else
        broadcast = 1
        if (setsockopt(lps, %SOL_SOCKET, %SO_BROADCAST, broadcast, sizeof(long)) = -1) then
            print "Could not set socket option"
            nDoIt = 0
        end if
    end if
    if (nDoIt) then
        RtlFillMemory(byval varptr(recvaddr), sizeof(sockaddr_in), 0)
        recvaddr.sin_family = %AF_INET
        recvaddr.sin_port = htons(%PORT_NUMBER)
        recvaddr.sin_addr.s_addr = %INADDR_ANY
        if (bind(lps, recvaddr, sizeof(sockaddr_in)) = -1) then
            print "Could not bind name to socket."
        else
            print "Press Escape to quit"
            RtlFillMemory(byval varptr(sendaddr), sizeof(sockaddr_in), 0)
            sendaddr.sin_family = %AF_INET
            sendaddr.sin_port = htons(%PORT_NUMBER)
            sendaddr.sin_addr.s_addr = %INADDR_ANY

            local zBuffer as asciiz * %BUFFER_SIZE
            addr_len = sizeof(sendaddr)
            do
                if (recvfrom(lps, zBuffer, sizeof(zBuffer), 0, sendaddr, addr_len) < 0) then
                    print "Error receiving data."
                else
                    '// Display server message
                    print "Server message is: " + zBuffer
                    if (zBuffer = "STOP") then exit do
                end if
            loop until asc(inkey$) = 27
        end if
    end if
    if (lps) then closesocket(lps)     
 
    WSACleanup()
    function = 0
end function