'// Sender
'// Broadcast datagram to multiple recipients
'// Author Patrice Terrier
'// www.zapsolution.com
'// Date: 10-06-2015

#BREAK ON
#COMPILE EXE "Sender.exe"
#Include "win32api.inc"
#Include "time.inc"

%PORT_NUMBER = 8000
$DEST_ADDR   = "255.255.255.255"
%BUFFER_SIZE = 4096
%DELAY       = 1000

function pbmain() as long
    local lps as DWORD                    '// Socket descriptor of server
    local nDoIt, broadcast, current_time as long
    local sendaddr as sockaddr_in
    local recvaddr as sockaddr_in
    local wsa as WSADATA                  '// Used to open windows connection
 
    '// Open windows connection
    if (WSAStartup(&h0202, wsa)) then
        print "Could not open Windows connection."
        function = 0: exit function
    end if

    nDoIt = -1
    lps = socket(%AF_INET, %SOCK_DGRAM, byval %NULL)
    if (lps = %INVALID_SOCKET) then
        print "Could not create socket."
        lps = 0
        nDoIt = 0
    else
        broadcast = 1
        if (setsockopt(lps, %SOL_SOCKET, %SO_BROADCAST, broadcast, sizeof(long)) = -1) then
            print "Could not set socket option"
            nDoIt = 0
        end if
    end if
    if (nDoIt) then
        RtlFillMemory(byval varptr(sendaddr), sizeof(sockaddr_in), 0)
        sendaddr.sin_family = %AF_INET
        sendaddr.sin_port = htons(%PORT_NUMBER)
        sendaddr.sin_addr.s_addr = %INADDR_ANY
 
        if (bind(lps, sendaddr, sizeof(sockaddr_in)) = -1) then
            print "Could not bind name to socket."
        else
            print "Press the Escape key to STOP everything"
            RtlFillMemory(byval varptr(recvaddr), sizeof(sockaddr_in), 0)
            recvaddr.sin_family = %AF_INET
            recvaddr.sin_port = htons(%PORT_NUMBER)
            recvaddr.sin_addr.s_addr = inet_addr($DEST_ADDR)
            local zBuffer as asciiz * %BUFFER_SIZE
            local nSTOP as long
            local nTick as dword
            nTick = GetTickCount() + %DELAY
            do
                 RtlFillMemory(byval varptr(zBuffer), sizeof(zBuffer), 0)
                 if (asc(inkey$) = 27) then
                     zBuffer = "STOP"
                     nSTOP = 27
                 else 
                     if (GetTickCount() > nTick) then
                         nTick = GetTickCount() + %DELAY
                         zBuffer = Time$
                     end if
                 end if
                 if (len(zBuffer)) then
                     print zBuffer
                     if (sendto(lps, zBuffer, sizeof(zBuffer), 0, recvaddr, sizeof(sockaddr_in)) <> sizeof(zBuffer)) then
                         print "Error sending datagram.": exit do
                     end if
                 end if
            loop until nSTOP = 27
        end if
    end if
    if (lps) then closesocket(lps)     
 
    WSACleanup()
    function = 0
end function
